
;CodeVisionAVR C Compiler V1.25.9 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 4,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "3310.vec"
	.INCLUDE "3310.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 //   2
;       2 #include <mega8.h>
;       3 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;       4 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;       5 	.EQU __se_bit=0x80
	.EQU __se_bit=0x80
;       6 	.EQU __sm_mask=0x70
	.EQU __sm_mask=0x70
;       7 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;       8 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;       9 	.EQU __sm_standby=0x60
	.EQU __sm_standby=0x60
;      10 	.EQU __sm_ext_standby=0x70
	.EQU __sm_ext_standby=0x70
;      11 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      12 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      13 	#endif
	#endif
;      14 
;      15 #include <spi.h>
;      16 #include <delay.h>
;      17 #include <stdio.h>
;      18 #include <delay.h>
;      19 #include <MATH.H>
;      20 //  Mega8 port B pinout for LCD.
;      21 #define lcd_dc_pin                 PORTB.0  //  PB0
;      22 #define lcd_ce_pin                 PORTB.2  //  PB2
;      23 #define spi_mosi_pin               PORTB.3  //  PB3
;      24 #define lcd_rst_pin                PORTB.4  //  PB4
;      25 #define spi_clk_pin                PORTB.5  //  PB5
;      26 
;      27 unsigned char font [91][5] =
_font:
;      28 {
;      29     {0x00, 0x00, 0x00, 0x00, 0x00},    // sp 0
;      30     {0x00, 0x00, 0x2f, 0x00, 0x00},    // !  1
;      31     {0x00, 0x07, 0x00, 0x07, 0x00},    // "  2
;      32     {0x14, 0x7f, 0x14, 0x7f, 0x14},    // #  3
;      33     {0x24, 0x2a, 0x7f, 0x2a, 0x12},    // $  4
;      34     {0x32, 0x34, 0x08, 0x16, 0x26},    // %  5
;      35     {0x36, 0x49, 0x55, 0x22, 0x50},    // &  6
;      36     {0x00, 0x05, 0x03, 0x00, 0x00},    // '  7
;      37     {0x00, 0x1c, 0x22, 0x41, 0x00},    // (  8
;      38     {0x00, 0x41, 0x22, 0x1c, 0x00},    // )  9
;      39     {0x14, 0x08, 0x3E, 0x08, 0x14},    // *  10
;      40     {0x08, 0x08, 0x3E, 0x08, 0x08},    // +  11
;      41     {0x00, 0x00, 0x50, 0x30, 0x00},    // ,  12
;      42     {0x10, 0x10, 0x10, 0x10, 0x10},    // -  13
;      43     {0x00, 0x60, 0x60, 0x00, 0x00},    // .  14
;      44     {0x20, 0x10, 0x08, 0x04, 0x02},    // /  15
;      45     {0x3E, 0x51, 0x49, 0x45, 0x3E},    // 0  16
;      46     {0x00, 0x42, 0x7F, 0x40, 0x00},    // 1  17
;      47     {0x42, 0x61, 0x51, 0x49, 0x46},    // 2  18
;      48     {0x21, 0x41, 0x45, 0x4B, 0x31},    // 3  19
;      49     {0x18, 0x14, 0x12, 0x7F, 0x10},    // 4  20
;      50     {0x27, 0x45, 0x45, 0x45, 0x39},    // 5  21
;      51     {0x3C, 0x4A, 0x49, 0x49, 0x30},    // 6  22
;      52     {0x01, 0x71, 0x09, 0x05, 0x03},    // 7  23
;      53     {0x36, 0x49, 0x49, 0x49, 0x36},    // 8  24
;      54     {0x06, 0x49, 0x49, 0x29, 0x1E},    // 9  25
;      55     {0x00, 0x36, 0x36, 0x00, 0x00},    // :  26
;      56     {0x00, 0x56, 0x36, 0x00, 0x00},    // ;  27
;      57     {0x08, 0x14, 0x22, 0x41, 0x00},    // <  28
;      58     {0x14, 0x14, 0x14, 0x14, 0x14},    // =  29
;      59     {0x00, 0x41, 0x22, 0x14, 0x08},    // >  30
;      60     {0x02, 0x01, 0x51, 0x09, 0x06},    // ?  31
;      61     {0x32, 0x49, 0x59, 0x51, 0x3E},    // @  32
;      62     {0x7E, 0x11, 0x11, 0x11, 0x7E},    // A  33
;      63     {0x7F, 0x49, 0x49, 0x49, 0x36},    // B  34
;      64     {0x3E, 0x41, 0x41, 0x41, 0x22},    // C  35
;      65     {0x7F, 0x41, 0x41, 0x22, 0x1C},    // D  36
;      66     {0x7F, 0x49, 0x49, 0x49, 0x41},    // E  37
;      67     {0x7F, 0x09, 0x09, 0x09, 0x01},    // F  38
;      68     {0x3E, 0x41, 0x49, 0x49, 0x7A},    // G  39
;      69     {0x7F, 0x08, 0x08, 0x08, 0x7F},    // H  40
;      70     {0x00, 0x41, 0x7F, 0x41, 0x00},    // I  41
;      71     {0x20, 0x40, 0x41, 0x3F, 0x01},    // J  42
;      72     {0x7F, 0x08, 0x14, 0x22, 0x41},    // K  43
;      73     {0x7F, 0x40, 0x40, 0x40, 0x40},    // L  44
;      74     {0x7F, 0x02, 0x0C, 0x02, 0x7F},    // M  45
;      75     {0x7F, 0x04, 0x08, 0x10, 0x7F},    // N  46
;      76     {0x3E, 0x41, 0x41, 0x41, 0x3E},    // O  47
;      77     {0x7F, 0x09, 0x09, 0x09, 0x06},    // P  48
;      78     {0x3E, 0x41, 0x51, 0x21, 0x5E},    // Q  49
;      79     {0x7F, 0x09, 0x19, 0x29, 0x46},    // R  50
;      80     {0x46, 0x49, 0x49, 0x49, 0x31},    // S  51
;      81     {0x01, 0x01, 0x7F, 0x01, 0x01},    // T  52
;      82     {0x3F, 0x40, 0x40, 0x40, 0x3F},    // U  53
;      83     {0x1F, 0x20, 0x40, 0x20, 0x1F},    // V  54
;      84     {0x3F, 0x40, 0x38, 0x40, 0x3F},    // W  55
;      85     {0x63, 0x14, 0x08, 0x14, 0x63},    // X  56
;      86     {0x07, 0x08, 0x70, 0x08, 0x07},    // Y  57
;      87     {0x61, 0x51, 0x49, 0x45, 0x43},    // Z  58
;      88     {0x00, 0x7F, 0x41, 0x41, 0x00},    // [  59
;      89     {0x55, 0x2A, 0x55, 0x2A, 0x55},    // 55 60
;      90     {0x00, 0x41, 0x41, 0x7F, 0x00},    // ]  61
;      91     {0x04, 0x02, 0x01, 0x02, 0x04},    // ^  62
;      92     {0x40, 0x40, 0x40, 0x40, 0x40},    // _  63
;      93     {0x00, 0x01, 0x02, 0x04, 0x00},    // '  64
;      94     {0x20, 0x54, 0x54, 0x54, 0x78},    // a  65
;      95     {0x7F, 0x48, 0x44, 0x44, 0x38},    // b  66
;      96     {0x38, 0x44, 0x44, 0x44, 0x20},    // c  67
;      97     {0x38, 0x44, 0x44, 0x48, 0x7F},    // d  68
;      98     {0x38, 0x54, 0x54, 0x54, 0x18},    // e  69
;      99     {0x08, 0x7E, 0x09, 0x01, 0x02},    // f  70
;     100     {0x0C, 0x52, 0x52, 0x52, 0x3E},    // g  71
;     101     {0x7F, 0x08, 0x04, 0x04, 0x78},    // h  72
;     102     {0x00, 0x44, 0x7D, 0x40, 0x00},    // i  73
;     103     {0x20, 0x40, 0x44, 0x3D, 0x00},    // j  74
;     104     {0x7F, 0x10, 0x28, 0x44, 0x00},    // k  75
;     105     {0x00, 0x41, 0x7F, 0x40, 0x00},    // l  76
;     106     {0x7C, 0x04, 0x18, 0x04, 0x78},    // m  77
;     107     {0x7C, 0x08, 0x04, 0x04, 0x78},    // n  78
;     108     {0x38, 0x44, 0x44, 0x44, 0x38},    // o  79
;     109     {0x7C, 0x14, 0x14, 0x14, 0x08},    // p  80
;     110     {0x08, 0x14, 0x14, 0x18, 0x7C},    // q  81
;     111     {0x7C, 0x08, 0x04, 0x04, 0x08},    // r  82
;     112     {0x48, 0x54, 0x54, 0x54, 0x20},    // s  83
;     113     {0x04, 0x3F, 0x44, 0x40, 0x20},    // t  84
;     114     {0x3C, 0x40, 0x40, 0x20, 0x7C},    // u  85
;     115     {0x1C, 0x20, 0x40, 0x20, 0x1C},    // v  86
;     116     {0x3C, 0x40, 0x30, 0x40, 0x3C},    // w  87
;     117     {0x44, 0x28, 0x10, 0x28, 0x44},    // x  88
;     118     {0x0C, 0x50, 0x50, 0x50, 0x3C},    // y  89
;     119     {0x44, 0x64, 0x54, 0x4C, 0x44}     // z  90
;     120 };
	.BYTE 0x1C7
;     121 
;     122 void lcd_send (unsigned char data, char cd)
;     123 {

	.CSEG
_lcd_send:
;     124 	lcd_ce_pin = 0;     //Enable display controller (active low) (5  SCE  0)
;	data -> Y+1
;	cd -> Y+0
	CBI  0x18,2
;     125 
;     126     if (cd == 1)      //cd=1   (cd  D/C)
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x6
;     127     {
;     128     lcd_dc_pin = 1;   //PORTB.0  4  D/S   
	SBI  0x18,0
;     129     }
;     130     else
	RJMP _0x9
_0x6:
;     131     {
;     132     lcd_dc_pin = 0;   //cd=0   PORTB.0  4  D/S
	CBI  0x18,0
;     133     }
_0x9:
;     134     spi (data);
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _spi
;     135 }
	RJMP _0xE2
;     136 
;     137 void lcd_gotoxy(unsigned int x, unsigned int y) //    X () Y ()
;     138 {
_lcd_gotoxy:
;     139     lcd_send (x | 0x80, 0);    //    proba  0x80=0b10000000
;	x -> Y+2
;	y -> Y+0
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ORI  R30,0x80
	RCALL SUBOPT_0x0
;     140     lcd_send (y | 0x40, 0);    //             0x40=0b01000000
	LD   R30,Y
	LDD  R31,Y+1
	ORI  R30,0x40
	RCALL SUBOPT_0x0
;     141 }                                //LCD_CMD   0
	ADIW R28,4
	RET
;     142 //y, y-1      ,   
;     143 //lcd_gotoxy(25,2);   217   
;     144 
;     145 void lcd_clear(void)      //  . .  . .==504
;     146 {
_lcd_clear:
;     147 	unsigned int i;
;     148 
;     149 	lcd_gotoxy(0,0);
	RCALL __SAVELOCR2
;	i -> R16,R17
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x1
	RCALL _lcd_gotoxy
;     150 
;     151 	for (i=0;i<504;++i)     //504 5 9   LCD_X_RES*LCD_Y_RES/8=48*84/8=504
	__GETWRN 16,17,0
_0xD:
	__CPWRN 16,17,504
	BRSH _0xE
;     152     {
;     153 		lcd_send(0,1);        //
	RCALL SUBOPT_0x2
;     154 	}                       // cd  = 1
	__ADDWRN 16,17,1
	RJMP _0xD
_0xE:
;     155 }
	RCALL __LOADLOCR2P
	RET
;     156 
;     157 void lcd_init (void)
;     158 {
_lcd_init:
;     159 	lcd_rst_pin = 1;   // 1  RES PORTB.4
	SBI  0x18,4
;     160 	delay_ms(50);      // 10 
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RCALL SUBOPT_0x3
;     161 	lcd_rst_pin = 0;   // 0  RES PORTB.4
	CBI  0x18,4
;     162 	delay_ms(500);     // 800 
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL SUBOPT_0x3
;     163 	lcd_rst_pin = 1;   // 1  RES PORTB.4
	SBI  0x18,4
;     164 
;     165 	lcd_ce_pin = 1;     //Disable LCD controller  PORTB.2=1
	SBI  0x18,2
;     166                       //.   PCD8544 .22           
;     167   lcd_send (0x21, 0); //Extended Commands.   step2                               4,7 
	LDI  R30,LOW(33)
	RCALL SUBOPT_0x0
;     168 	lcd_send (0xAA, 0); //Set LCD Vop (Contrast). 0xC8=8,54 0xC5=8,35  01=8,1 0xB1=7,07
	LDI  R30,LOW(170)
	RCALL SUBOPT_0x0
;     169 	lcd_send (0x06, 0); //Set Temp coefficent.
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x0
;     170 	lcd_send (0x13, 0); //bias mode 1:48.
	LDI  R30,LOW(19)
	RCALL SUBOPT_0x0
;     171 	lcd_send (0x20, 0); //Horizontal addressing mode. step4
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x0
;     172 	lcd_send (0x0C, 0); //normal mode.     step5
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x0
;     173 
;     174 
;     175     lcd_clear();  // Clear lcd
	RCALL _lcd_clear
;     176 }
	RET
;     177 
;     178 void lcd_putch (unsigned char c)  //  198 
;     179 {                                 //    . 
_lcd_putch:
;     180     unsigned char i=0;
;     181 
;     182     for (i=0; i<5; i++)           //  5!!! 
	ST   -Y,R17
;	c -> Y+1
;	i -> R17
	LDI  R17,0
	LDI  R17,LOW(0)
_0x18:
	CPI  R17,5
	BRSH _0x19
;     183     {
;     184     lcd_send (font[c-32][i],1);   //
	LDD  R30,Y+1
	SUBI R30,LOW(32)
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_font)
	SBCI R31,HIGH(-_font)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_send
;     185     }
	SUBI R17,-1
	RJMP _0x18
_0x19:
;     186                       //   !!!!!!!
;     187 	lcd_send(0x00,1);   //  ,  
	RCALL SUBOPT_0x2
;     188 }                     //  .   1
	LDD  R17,Y+0
	RJMP _0xE2
;     189                       //    . 000 
;     190 
;     191 
;     192 void lcd_putstr (char *s)  //void lcd_putstr (const char *s)
;     193 {
_lcd_putstr:
;     194 	while (*s)          //  *s>0
;	*s -> Y+0
_0x1A:
	LD   R26,Y
	LDD  R27,Y+1
	LD   R30,X
	CPI  R30,0
	BREQ _0x1C
;     195     {
;     196 		lcd_putch(*s);
	ST   -Y,R30
	RCALL _lcd_putch
;     197 		s++;
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R30,1
	ST   Y,R30
	STD  Y+1,R31
;     198 	}
	RJMP _0x1A
_0x1C:
;     199 }
_0xE2:
	ADIW R28,2
	RET
;     200 
;     201 unsigned char str [14];       //     

	.DSEG
_str:
	.BYTE 0xE
;     202 unsigned int adc_data;        //  
;     203 //float U;
;     204 
;     205 // ADC interrupt service routine
;     206 interrupt [ADC_INT] void adc_isr(void) //   
;     207 {

	.CSEG
_adc_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     208 adc_data=ADCW; //    ads_data
	__INWR 4,5,4
;     209 //U=adc_data;
;     210 lcd_clear();
	RCALL _lcd_clear
;     211 lcd_gotoxy(25,2);                   //  1-   ; 2-   
	LDI  R30,LOW(25)
	LDI  R31,HIGH(25)
	RCALL SUBOPT_0x4
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RCALL SUBOPT_0x4
	RCALL _lcd_gotoxy
;     212 sprintf(str, "V=%-4u",(adc_data*5-adc_data/10));    //sprintf(str, "V=%-4u",(adc_data*5-adc_data/10));
	LDI  R30,LOW(_str)
	LDI  R31,HIGH(_str)
	RCALL SUBOPT_0x4
	__POINTW1FN _0,0
	RCALL SUBOPT_0x4
	MOVW R26,R4
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL __MULW12U
	MOVW R22,R30
	MOVW R26,R4
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	MOVW R26,R30
	MOVW R30,R22
	SUB  R30,R26
	SBC  R31,R27
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
;     213 lcd_putstr (str);                   //  
	LDI  R30,LOW(_str)
	LDI  R31,HIGH(_str)
	RCALL SUBOPT_0x4
	RCALL _lcd_putstr
;     214 delay_ms (500);                     //
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL SUBOPT_0x3
;     215 };
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     216 
;     217 void main(void)
;     218 {
_main:
;     219 
;     220  DDRB=0b00111101;       //PORTB.0, PORTB.2 - PORTB.5  .
	LDI  R30,LOW(61)
	OUT  0x17,R30
;     221 PORTB=0b00101101;       //  1 .
	LDI  R30,LOW(45)
	OUT  0x18,R30
;     222 
;     223  DDRC=0b0000000;      //  .
	LDI  R30,LOW(0)
	OUT  0x14,R30
;     224 PORTC=0b0000000;      //  .
	OUT  0x15,R30
;     225 
;     226  DDRD=0b00000000;     //  .
	OUT  0x11,R30
;     227 PORTD=0b00000000;     //  .
	OUT  0x12,R30
;     228 
;     229 //Enable SPI port: No interrupt, MSBit first, Master mode, CPOL->0, CPHA->0, Clk/4
;     230 SPCR=0b01010000;      //SPI Control Register  SPCR  . 126 ATmega8  0b01010011 
	LDI  R30,LOW(80)
	OUT  0xD,R30
;     231 //SPSR=0b00000001;      //SPI Status Register  SPSR . 128 ATmega8
;     232 
;     233 // 
;     234 //   101=k=32 4000/32=125    
;     235 
;     236 ADCSRA=0b10001101;   //7-  3-. 101   32
	LDI  R30,LOW(141)
	OUT  0x6,R30
;     237 
;     238 ADMUX=0b00000000;    //0-  -PC0,  
	LDI  R30,LOW(0)
	OUT  0x7,R30
;     239 
;     240 //  
;     241 ADCSRA|=0x60;        //ADCSRA|=0x60;=0b1000000    
	IN   R30,0x6
	ORI  R30,LOW(0x60)
	OUT  0x6,R30
;     242 
;     243 lcd_init();          //  156 
	RCALL _lcd_init
;     244 
;     245 //delay_us (100);      //
;     246 
;     247 lcd_clear();         //  *** 
	RCALL _lcd_clear
;     248 
;     249 #asm("sei")          //  lcd_init !!!!!!!!!!!!!!!!!
	sei
;     250 while (1){}
_0x1D:
	RJMP _0x1D
;     251 }
_0x20:
	RJMP _0x20

	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
_spi:
	LD   R30,Y
	OUT  0xF,R30
_0x21:
	SBIS 0xE,7
	RJMP _0x21
	IN   R30,0xF
	ADIW R28,1
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G3:
	RCALL __SAVELOCR2
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0x31
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x33
	__CPWRN 16,17,2
	BRLO _0x34
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x33:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x34:
	RJMP _0x35
_0x31:
	LDD  R30,Y+6
	ST   -Y,R30
	RCALL _putchar
_0x35:
	RCALL __LOADLOCR2
	ADIW R28,7
	RET
__print_G3:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
_0x36:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x38
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x3C
	CPI  R18,37
	BRNE _0x3D
	LDI  R17,LOW(1)
	RJMP _0x3E
_0x3D:
	RCALL SUBOPT_0x5
_0x3E:
	RJMP _0x3B
_0x3C:
	CPI  R30,LOW(0x1)
	BRNE _0x3F
	CPI  R18,37
	BRNE _0x40
	RCALL SUBOPT_0x5
	RJMP _0xE3
_0x40:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x41
	LDI  R16,LOW(1)
	RJMP _0x3B
_0x41:
	CPI  R18,43
	BRNE _0x42
	LDI  R20,LOW(43)
	RJMP _0x3B
_0x42:
	CPI  R18,32
	BRNE _0x43
	LDI  R20,LOW(32)
	RJMP _0x3B
_0x43:
	RJMP _0x44
_0x3F:
	CPI  R30,LOW(0x2)
	BRNE _0x45
_0x44:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x46
	ORI  R16,LOW(128)
	RJMP _0x3B
_0x46:
	RJMP _0x47
_0x45:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x3B
_0x47:
	CPI  R18,48
	BRLO _0x4A
	CPI  R18,58
	BRLO _0x4B
_0x4A:
	RJMP _0x49
_0x4B:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x3B
_0x49:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x4F
	RCALL SUBOPT_0x6
	LD   R30,X
	RCALL SUBOPT_0x7
	RJMP _0x50
_0x4F:
	CPI  R30,LOW(0x73)
	BRNE _0x52
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x8
	RCALL _strlen
	MOV  R17,R30
	RJMP _0x53
_0x52:
	CPI  R30,LOW(0x70)
	BRNE _0x55
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x8
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x53:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x56
_0x55:
	CPI  R30,LOW(0x64)
	BREQ _0x59
	CPI  R30,LOW(0x69)
	BRNE _0x5A
_0x59:
	ORI  R16,LOW(4)
	RJMP _0x5B
_0x5A:
	CPI  R30,LOW(0x75)
	BRNE _0x5C
_0x5B:
	LDI  R30,LOW(_tbl10_G3*2)
	LDI  R31,HIGH(_tbl10_G3*2)
	RCALL SUBOPT_0x9
	LDI  R17,LOW(5)
	RJMP _0x5D
_0x5C:
	CPI  R30,LOW(0x58)
	BRNE _0x5F
	ORI  R16,LOW(8)
	RJMP _0x60
_0x5F:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x91
_0x60:
	LDI  R30,LOW(_tbl16_G3*2)
	LDI  R31,HIGH(_tbl16_G3*2)
	RCALL SUBOPT_0x9
	LDI  R17,LOW(4)
_0x5D:
	SBRS R16,2
	RJMP _0x62
	RCALL SUBOPT_0x6
	RCALL __GETW1P
	RCALL SUBOPT_0xA
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x63
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	RCALL SUBOPT_0xA
	LDI  R20,LOW(45)
_0x63:
	CPI  R20,0
	BREQ _0x64
	SUBI R17,-LOW(1)
	RJMP _0x65
_0x64:
	ANDI R16,LOW(251)
_0x65:
	RJMP _0x66
_0x62:
	RCALL SUBOPT_0x6
	RCALL __GETW1P
	RCALL SUBOPT_0xA
_0x66:
_0x56:
	SBRC R16,0
	RJMP _0x67
_0x68:
	CP   R17,R21
	BRSH _0x6A
	SBRS R16,7
	RJMP _0x6B
	SBRS R16,2
	RJMP _0x6C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x6D
_0x6C:
	LDI  R18,LOW(48)
_0x6D:
	RJMP _0x6E
_0x6B:
	LDI  R18,LOW(32)
_0x6E:
	RCALL SUBOPT_0x5
	SUBI R21,LOW(1)
	RJMP _0x68
_0x6A:
_0x67:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x6F
_0x70:
	CPI  R19,0
	BREQ _0x72
	SBRS R16,3
	RJMP _0x73
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	RCALL SUBOPT_0x9
	SBIW R30,1
	LPM  R30,Z
	RJMP _0xE4
_0x73:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0xE4:
	ST   -Y,R30
	RCALL SUBOPT_0xB
	CPI  R21,0
	BREQ _0x75
	SUBI R21,LOW(1)
_0x75:
	SUBI R19,LOW(1)
	RJMP _0x70
_0x72:
	RJMP _0x76
_0x6F:
_0x78:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	RCALL SUBOPT_0x9
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0x7A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x7C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	RCALL SUBOPT_0xA
	RJMP _0x7A
_0x7C:
	CPI  R18,58
	BRLO _0x7D
	SBRS R16,3
	RJMP _0x7E
	SUBI R18,-LOW(7)
	RJMP _0x7F
_0x7E:
	SUBI R18,-LOW(39)
_0x7F:
_0x7D:
	SBRC R16,4
	RJMP _0x81
	CPI  R18,49
	BRSH _0x83
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x82
_0x83:
	RJMP _0xE5
_0x82:
	CP   R21,R19
	BRLO _0x87
	SBRS R16,0
	RJMP _0x88
_0x87:
	RJMP _0x86
_0x88:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x89
	LDI  R18,LOW(48)
_0xE5:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x8A
	ANDI R16,LOW(251)
	ST   -Y,R20
	RCALL SUBOPT_0xB
	CPI  R21,0
	BREQ _0x8B
	SUBI R21,LOW(1)
_0x8B:
_0x8A:
_0x89:
_0x81:
	RCALL SUBOPT_0x5
	CPI  R21,0
	BREQ _0x8C
	SUBI R21,LOW(1)
_0x8C:
_0x86:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x79
	RJMP _0x78
_0x79:
_0x76:
	SBRS R16,0
	RJMP _0x8D
_0x8E:
	CPI  R21,0
	BREQ _0x90
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x7
	RJMP _0x8E
_0x90:
_0x8D:
_0x91:
_0x50:
_0xE3:
	LDI  R17,LOW(0)
_0x3B:
	RJMP _0x36
_0x38:
	RCALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	RCALL __SAVELOCR2
	MOVW R26,R28
	RCALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,6
	RCALL __ADDW2R15
	RCALL __GETW1P
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL __ADDW2R15
	RCALL __GETW1P
	RCALL SUBOPT_0x4
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x1
	RCALL __print_G3
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	RCALL __LOADLOCR2
	ADIW R28,4
	POP  R15
	RET
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
    lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.DSEG
_p_S5A:
	.BYTE 0x2

	.CSEG

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x0:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RJMP _lcd_send

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RJMP _lcd_send

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 25 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x4:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x5:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x4
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x4
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x6:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	SBIW R26,4
	STD  Y+16,R26
	STD  Y+16+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x7:
	ST   -Y,R30
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x4
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x4
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x8:
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA:
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xB:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x4
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x4
	RJMP __put_G3

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
