//   2
// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega8


#pragma used+
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm



/*
  CodeVisionAVR C Compiler
  (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

  Prototype for SPI access function */
  

#pragma used+
#pragma used+
unsigned char spi(unsigned char data);
#pragma used-

#pragma library spi.lib

// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;
typedef char *va_list;
typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.





/*
CodeVisionAVR C Compiler
Prototypes for mathematical functions

Portions (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.
Portions (C) 2000-2001 Yuri G. Salov
*/



#pragma used+
#pragma used+
#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib


//  Mega8 port B pinout for LCD.

unsigned char font [91][5] =
{
    {0x00, 0x00, 0x00, 0x00, 0x00},    // sp 0
    {0x00, 0x00, 0x2f, 0x00, 0x00},    // !  1
    {0x00, 0x07, 0x00, 0x07, 0x00},    // "  2
    {0x14, 0x7f, 0x14, 0x7f, 0x14},    // #  3
    {0x24, 0x2a, 0x7f, 0x2a, 0x12},    // $  4
    {0x32, 0x34, 0x08, 0x16, 0x26},    // %  5
    {0x36, 0x49, 0x55, 0x22, 0x50},    // &  6
    {0x00, 0x05, 0x03, 0x00, 0x00},    // '  7
    {0x00, 0x1c, 0x22, 0x41, 0x00},    // (  8
    {0x00, 0x41, 0x22, 0x1c, 0x00},    // )  9
    {0x14, 0x08, 0x3E, 0x08, 0x14},    // *  10
    {0x08, 0x08, 0x3E, 0x08, 0x08},    // +  11
    {0x00, 0x00, 0x50, 0x30, 0x00},    // ,  12
    {0x10, 0x10, 0x10, 0x10, 0x10},    // -  13
    {0x00, 0x60, 0x60, 0x00, 0x00},    // .  14
    {0x20, 0x10, 0x08, 0x04, 0x02},    // /  15
    {0x3E, 0x51, 0x49, 0x45, 0x3E},    // 0  16
    {0x00, 0x42, 0x7F, 0x40, 0x00},    // 1  17
    {0x42, 0x61, 0x51, 0x49, 0x46},    // 2  18
    {0x21, 0x41, 0x45, 0x4B, 0x31},    // 3  19
    {0x18, 0x14, 0x12, 0x7F, 0x10},    // 4  20
    {0x27, 0x45, 0x45, 0x45, 0x39},    // 5  21
    {0x3C, 0x4A, 0x49, 0x49, 0x30},    // 6  22
    {0x01, 0x71, 0x09, 0x05, 0x03},    // 7  23
    {0x36, 0x49, 0x49, 0x49, 0x36},    // 8  24
    {0x06, 0x49, 0x49, 0x29, 0x1E},    // 9  25
    {0x00, 0x36, 0x36, 0x00, 0x00},    // :  26
    {0x00, 0x56, 0x36, 0x00, 0x00},    // ;  27
    {0x08, 0x14, 0x22, 0x41, 0x00},    // <  28
    {0x14, 0x14, 0x14, 0x14, 0x14},    // =  29
    {0x00, 0x41, 0x22, 0x14, 0x08},    // >  30
    {0x02, 0x01, 0x51, 0x09, 0x06},    // ?  31
    {0x32, 0x49, 0x59, 0x51, 0x3E},    // @  32
    {0x7E, 0x11, 0x11, 0x11, 0x7E},    // A  33
    {0x7F, 0x49, 0x49, 0x49, 0x36},    // B  34
    {0x3E, 0x41, 0x41, 0x41, 0x22},    // C  35
    {0x7F, 0x41, 0x41, 0x22, 0x1C},    // D  36
    {0x7F, 0x49, 0x49, 0x49, 0x41},    // E  37
    {0x7F, 0x09, 0x09, 0x09, 0x01},    // F  38
    {0x3E, 0x41, 0x49, 0x49, 0x7A},    // G  39
    {0x7F, 0x08, 0x08, 0x08, 0x7F},    // H  40
    {0x00, 0x41, 0x7F, 0x41, 0x00},    // I  41
    {0x20, 0x40, 0x41, 0x3F, 0x01},    // J  42
    {0x7F, 0x08, 0x14, 0x22, 0x41},    // K  43
    {0x7F, 0x40, 0x40, 0x40, 0x40},    // L  44
    {0x7F, 0x02, 0x0C, 0x02, 0x7F},    // M  45
    {0x7F, 0x04, 0x08, 0x10, 0x7F},    // N  46
    {0x3E, 0x41, 0x41, 0x41, 0x3E},    // O  47
    {0x7F, 0x09, 0x09, 0x09, 0x06},    // P  48
    {0x3E, 0x41, 0x51, 0x21, 0x5E},    // Q  49
    {0x7F, 0x09, 0x19, 0x29, 0x46},    // R  50
    {0x46, 0x49, 0x49, 0x49, 0x31},    // S  51
    {0x01, 0x01, 0x7F, 0x01, 0x01},    // T  52
    {0x3F, 0x40, 0x40, 0x40, 0x3F},    // U  53
    {0x1F, 0x20, 0x40, 0x20, 0x1F},    // V  54          
    {0x3F, 0x40, 0x38, 0x40, 0x3F},    // W  55
    {0x63, 0x14, 0x08, 0x14, 0x63},    // X  56
    {0x07, 0x08, 0x70, 0x08, 0x07},    // Y  57
    {0x61, 0x51, 0x49, 0x45, 0x43},    // Z  58
    {0x00, 0x7F, 0x41, 0x41, 0x00},    // [  59
    {0x55, 0x2A, 0x55, 0x2A, 0x55},    // 55 60
    {0x00, 0x41, 0x41, 0x7F, 0x00},    // ]  61
    {0x04, 0x02, 0x01, 0x02, 0x04},    // ^  62
    {0x40, 0x40, 0x40, 0x40, 0x40},    // _  63
    {0x00, 0x01, 0x02, 0x04, 0x00},    // '  64
    {0x20, 0x54, 0x54, 0x54, 0x78},    // a  65
    {0x7F, 0x48, 0x44, 0x44, 0x38},    // b  66
    {0x38, 0x44, 0x44, 0x44, 0x20},    // c  67
    {0x38, 0x44, 0x44, 0x48, 0x7F},    // d  68
    {0x38, 0x54, 0x54, 0x54, 0x18},    // e  69
    {0x08, 0x7E, 0x09, 0x01, 0x02},    // f  70
    {0x0C, 0x52, 0x52, 0x52, 0x3E},    // g  71
    {0x7F, 0x08, 0x04, 0x04, 0x78},    // h  72
    {0x00, 0x44, 0x7D, 0x40, 0x00},    // i  73
    {0x20, 0x40, 0x44, 0x3D, 0x00},    // j  74
    {0x7F, 0x10, 0x28, 0x44, 0x00},    // k  75
    {0x00, 0x41, 0x7F, 0x40, 0x00},    // l  76
    {0x7C, 0x04, 0x18, 0x04, 0x78},    // m  77
    {0x7C, 0x08, 0x04, 0x04, 0x78},    // n  78
    {0x38, 0x44, 0x44, 0x44, 0x38},    // o  79
    {0x7C, 0x14, 0x14, 0x14, 0x08},    // p  80
    {0x08, 0x14, 0x14, 0x18, 0x7C},    // q  81
    {0x7C, 0x08, 0x04, 0x04, 0x08},    // r  82
    {0x48, 0x54, 0x54, 0x54, 0x20},    // s  83
    {0x04, 0x3F, 0x44, 0x40, 0x20},    // t  84
    {0x3C, 0x40, 0x40, 0x20, 0x7C},    // u  85
    {0x1C, 0x20, 0x40, 0x20, 0x1C},    // v  86
    {0x3C, 0x40, 0x30, 0x40, 0x3C},    // w  87
    {0x44, 0x28, 0x10, 0x28, 0x44},    // x  88
    {0x0C, 0x50, 0x50, 0x50, 0x3C},    // y  89
    {0x44, 0x64, 0x54, 0x4C, 0x44}     // z  90
};

void lcd_send (unsigned char data, char cd)
{ 
	PORTB.2   = 0;     //Enable display controller (active low) (5  SCE  0)
	
    if (cd == 1)      //cd=1   (cd  D/C) 
    {
    PORTB.0   = 1;   //PORTB.0  4  D/S    
    }
    else
    {
    PORTB.0   = 0;   //cd=0   PORTB.0  4  D/S 
    }
    spi (data);
}

void lcd_gotoxy(unsigned int x, unsigned int y) //    X () Y ()
{
    lcd_send (x | 0x80, 0);    //    proba  0x80=0b10000000
    lcd_send (y | 0x40, 0);    //             0x40=0b01000000
}                                //LCD_CMD   0 
//y, y-1      ,   
//lcd_gotoxy(25,2);   217   

void lcd_clear(void)      //  . .  . .==504
{
	unsigned int i;

	lcd_gotoxy(0,0);      

	for (i=0;i<504;++i)     //504 5 9   LCD_X_RES*LCD_Y_RES/8=48*84/8=504
    {
		lcd_send(0,1);        //     
	}                       // cd  = 1
}

void lcd_init (void)
{
	PORTB.4   = 1;   // 1  RES PORTB.4
	delay_ms(50);      // 10 
	PORTB.4   = 0;   // 0  RES PORTB.4
	delay_ms(500);     // 800 
	PORTB.4   = 1;   // 1  RES PORTB.4
	
	PORTB.2   = 1;     //Disable LCD controller  PORTB.2=1
                      //.   PCD8544 .22           
  lcd_send (0x21, 0); //Extended Commands.   step2                               4,7 
	lcd_send (0xAA, 0); //Set LCD Vop (Contrast). 0xC8=8,54 0xC5=8,35  01=8,1 0xB1=7,07
	lcd_send (0x06, 0); //Set Temp coefficent.            
	lcd_send (0x13, 0); //bias mode 1:48.                 
	lcd_send (0x20, 0); //Horizontal addressing mode. step4  
	lcd_send (0x0C, 0); //normal mode.     step5          
	

    lcd_clear();  // Clear lcd
}

void lcd_putch (unsigned char c)  //  198 
{                                 //    . 
    unsigned char i=0;

    for (i=0; i<5; i++)           //  5!!! 
    {
    lcd_send (font[c-32][i],1);   //
    }
                      //   !!!!!!!
	lcd_send(0x00,1);   //  ,  
}                     //  .   1
                      //    . 000 


void lcd_putstr (char *s)  //void lcd_putstr (const char *s)
{
	while (*s)          //  *s>0
    {
		lcd_putch(*s);
		s++;
	}
}

unsigned char str [14];       //     
unsigned int adc_data;        //  
//float U;

// ADC interrupt service routine
interrupt [15] void adc_isr(void) //   
{
adc_data=ADCW; //    ads_data
//U=adc_data;
lcd_clear();
lcd_gotoxy(25,2);                   //  1-   ; 2-   
sprintf(str, "V=%-4u",(adc_data*5-adc_data/10));    //sprintf(str, "V=%-4u",(adc_data*5-adc_data/10));
lcd_putstr (str);                   //  
delay_ms (500);                     //
};

void main(void)
{

 DDRB=0b00111101;       //PORTB.0, PORTB.2 - PORTB.5  . 
PORTB=0b00101101;       //  1 .

 DDRC=0b0000000;      //  .
PORTC=0b0000000;      //  .

 DDRD=0b00000000;     //  .
PORTD=0b00000000;     //  .

//Enable SPI port: No interrupt, MSBit first, Master mode, CPOL->0, CPHA->0, Clk/4
SPCR=0b01010000;      //SPI Control Register  SPCR  . 126 ATmega8  0b01010011 
//SPSR=0b00000001;      //SPI Status Register  SPSR . 128 ATmega8

//  
//   101=k=32 4000/32=125    

ADCSRA=0b10001101;   //7-  3-. 101   32

ADMUX=0b00000000;    //0-  -PC0,  

//  
ADCSRA|=0x60;        //ADCSRA|=0x60;=0b1000000    

lcd_init();          //  156 

//delay_us (100);      //

lcd_clear();         //  *** 

#asm("sei")          //  lcd_init !!!!!!!!!!!!!!!!!
while (1){}
}
